import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class BluerDialog extends JDialog implements ActionListener, ChangeListener, ComponentListener {

	private j8ph _owner;

	private Box _views, _0fields, _1fields, _2fields, _buttons;

	private PixelsViewer _viewO, _viewP;
	private JLabel _viewLabel;

	private JLabel _0label, _1label, _2label;
	private JSlider _0slider, _1slider, _2slider;

	private JButton _btnExec, _btnPreview, _btnCancel;

	private int _0pix, _1pix, _2pix;

	private int[] _original;
	private JIntFrameBuffer _preview;

	public BluerDialog(j8ph owner, JIntFrameBuffer buf) {

		super(owner, "ぼかし", true);

		_owner = owner;

		int w = buf.getWidth();
		int h = buf.getHeight();

		int width = 0;
		int height = 0;

		if (w < j8ph.PREVIEW_SIZE) {
			width = w;
		} else {
			width = j8ph.PREVIEW_SIZE;
		}

		if (h < j8ph.PREVIEW_SIZE) {
			height = h;
		} else {
			height = j8ph.PREVIEW_SIZE;
		}

		_views = Box.createHorizontalBox();

		_original = buf.getSubPixels(0, 0, width, height);
		_preview = new JIntFrameBuffer(_original);

		_viewO = new PixelsViewer(_original);
		_viewLabel = new JLabel("→");
		_viewP = new PixelsViewer(_original);

		_views.add(_viewO);
		_views.add(_viewLabel);
		_views.add(_viewP);

		_0fields = Box.createHorizontalBox();

		_0label = new JLabel("中心ピクセル:100%");
		_0slider = new JSlider(0, 100, 100);
		_0slider.addChangeListener(this);

		_0fields.add(Box.createHorizontalStrut(4));
		_0fields.add(_0label);
		_0fields.add(Box.createHorizontalStrut(4));
		_0fields.add(_0slider);

		_1fields = Box.createHorizontalBox();

		_1label = new JLabel("距離1のピクセル:0%");
		_1slider = new JSlider(0, 100, 0);
		_1slider.addChangeListener(this);

		_1fields.add(Box.createHorizontalStrut(4));
		_1fields.add(_1label);
		_1fields.add(Box.createHorizontalStrut(4));
		_1fields.add(_1slider);

		_2fields = Box.createHorizontalBox();

		_2label = new JLabel("距離2のピクセル:0%");
		_2slider = new JSlider(0, 100, 0);
		_2slider.addChangeListener(this);

		_2fields.add(Box.createHorizontalStrut(4));
		_2fields.add(_2label);
		_2fields.add(Box.createHorizontalStrut(4));
		_2fields.add(_2slider);

		_buttons = Box.createHorizontalBox();

		_btnExec = new JButton("実行");
		_btnExec.addActionListener(this);

		_btnPreview = new JButton("確認");
		_btnPreview.addActionListener(this);

		_btnCancel = new JButton("中止");
		_btnCancel.addActionListener(this);

		// ボタン欄作成
		_buttons.add(_btnExec);
		_buttons.add(Box.createHorizontalStrut(4));
		_buttons.add(_btnPreview);
		_buttons.add(Box.createHorizontalStrut(4));
		_buttons.add(_btnCancel);

		Container c = getContentPane();

		c.setLayout(new BoxLayout(c, BoxLayout.Y_AXIS));

		c.add(Box.createVerticalStrut(4));
		c.add(_views);
		c.add(Box.createVerticalStrut(4));
		c.add(_0fields);
		c.add(Box.createVerticalStrut(4));
		c.add(_1fields);
		c.add(Box.createVerticalStrut(4));
		c.add(_2fields);
		c.add(Box.createVerticalStrut(8));
		c.add(_buttons);
		c.add(Box.createVerticalStrut(4));

		setResizable(false);
		pack();

		// アプリケーションの位置取得
		Rectangle rec = owner.getBounds(null);

		// アプリケーション中央座標算出
		int appCenterX = rec.x + rec.width / 2;
		int appCenterY = rec.y + rec.height / 2;

		// ダイアログをアプリケーション中央座標にあわせて配置
		setLocation(appCenterX - getWidth() / 2, appCenterY - getHeight() / 2);

		_0pix = -1;
		_1pix = -1;
		_2pix = -1;

		addComponentListener(this);

	}

	public int get0Pix() {
		return _0pix;
	}

	public int get1Pix() {
		return _1pix;
	}

	public int get2Pix() {
		return _2pix;
	}

	public void actionPerformed(ActionEvent e) {

		// 「実行」ボタン
		if (e.getSource() == _btnExec) {

			_0pix = _0slider.getValue();
			_1pix = _1slider.getValue();
			_2pix = _2slider.getValue();

			hide();

		}

		// 「確認」ボタン
		if (e.getSource() == _btnPreview) {

			int p0 = _0slider.getValue();
			int p1 = _1slider.getValue();
			int p2 = _2slider.getValue();

			_preview.assign(_original);

			repaint();

			_preview.bluer(p0, p1, p2);

			_viewP.setPixels(_preview.getPixels());

			repaint();

		}

		if (e.getSource() == _btnCancel) {

			_0pix = -1;
			_1pix = -1;
			_2pix = -1;

			hide();

		}

	}

	public void stateChanged(ChangeEvent e) {

		if (e.getSource() == _0slider) {

			int val = _0slider.getValue();

			_0label.setText("中心ピクセル:" + String.valueOf(val) + "%");

		}

		if (e.getSource() == _1slider) {

			int val = _1slider.getValue();

			_1label.setText("距離1のピクセル:" + String.valueOf(val) + "%");

		}

		if (e.getSource() == _2slider) {

			int val = _2slider.getValue();

			_2label.setText("距離2のピクセル:" + String.valueOf(val) + "%");

		}

	}

	public void componentHidden(ComponentEvent e) {
	}

	public void componentMoved(ComponentEvent e) {
		_owner.repaint();
	}

	public void componentResized(ComponentEvent e) {
	}

	public void componentShown(ComponentEvent e) {
	}

}
