import java.awt.*;
import java.awt.datatransfer.*;

public class ImageSelection implements Transferable, ClipboardOwner {

	Image _img;

	public ImageSelection(Image img) {
		_img = img;
	}

	public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException {

		if (DataFlavor.imageFlavor.equals(flavor)) {
			return _img;
		}

		throw new UnsupportedFlavorException(flavor);

	}

	public DataFlavor[] getTransferDataFlavors() {
		return new DataFlavor[] {DataFlavor.imageFlavor};
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return DataFlavor.imageFlavor.equals(flavor);
	}

	public void lostOwnership(Clipboard clipboard, Transferable contents) {
		_img = null;
	}
}
