import java.awt.image.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class PixelsViewer extends JComponent {

	private int _width, _height;

	private Image _img;

	PixelsViewer(int[] pixels) {

		super();

		setPixels(pixels);

	}

	public boolean setPixels(int[] src) {

		if (src == null) {
			return false;
		}

		int width = src[0];
		int height = src[1];

		_img = new BufferedImage(width, height, BufferedImage.TYPE_INT_BGR);
		((BufferedImage)_img).setRGB(0, 0, width, height, src, 2, width);

		if (width != _width || height != _height) {

			_width = width;
			_height = height;

			setSize(_width, _height);
			setPreferredSize(new Dimension(_width, _height));

		}

		repaint();

		return true;

	}

	public void paintComponent(Graphics g) {
		if (_img != null) {
			g.drawImage(_img, 0, 0, null);
		}
	}

}
