/**
	Javaフォトレタッチ Version 0.90

	2008/ 1/ 1 宍戸　輝光
*/

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.net.*;

import java.util.*;
import javax.imageio.*;

public class j8ph extends JFrame implements MenuListener, ActionListener, DropTargetListener {

	private String _appName = "Javaフォトレタッチ";

	private BMPanel m_bp;
	private JLabel m_lState;

	private JMenuBar _mbMain;

	private JMenu _menuFile, _menuDef, _menuEdit, _menuInfo, _menuTransform, _menuCond, _menuFilter, _menuHelp;
	private JMenuItem _mitemJpgQuality;
	private JMenu _smenuViewSize;
	private JRadioButtonMenuItem _mitemVS14, _mitemVS12, _mitemVS11;

	private JMenuItem _mitemOpen, _mitemDownload, _mitemSave, _mitemSaveAs, _mitemExit;
	private JMenuItem _mitemUndo, _mitemPaste, _mitemCopy;
	private JMenuItem _mitemSize, _mitemColors, _mitemPost, _mitemXor, _mitemGray;
	private JMenuItem _mitemResize, _mitemRGBFunc;
	private JMenuItem _mitemCondRGB, _mitemCondHSB, _mitemCondGamma;
	private JMenuItem _mitemBluer, _mitemUnsharp, _mitemOilPaint, _mitemPcamera;
	private JMenuItem _mitemAbout;

	private JScrollPane m_jp;

	private JIntFrameBuffer m_frame;

	private JIntFrameBuffer[] _undo;
	private int _undoIndex;

	private File _currentDir, _currentFile;

	private final int UNDO_LEVEL = 2;

	static public int MAX_WIDTH = 4096;
	static public int MAX_HEIGHT = 4096;

	private int _vsSize;
	private int _jpgQuality;

	private boolean _save;

	// ダイアログ内のプレビューサイズ
	public static int PREVIEW_SIZE;

	public j8ph() {

		setSize(new Dimension(600, 400));

		_mbMain=new JMenuBar();

		_menuFile = new JMenu("ファイル(F)");
		_menuFile.setMnemonic(KeyEvent.VK_F);
		_menuFile.addMenuListener(this);

		_mitemOpen = new JMenuItem("開く(O)");
		_mitemOpen.setMnemonic(KeyEvent.VK_O);
		_mitemDownload = new JMenuItem("ダウンロード(D");
		_mitemDownload.setMnemonic(KeyEvent.VK_D);
		_mitemSave = new JMenuItem("上書き保存(S)");
		_mitemSave.setMnemonic(KeyEvent.VK_S);
		_mitemSaveAs = new JMenuItem("名前をつけて保存(A)");
		_mitemSaveAs.setMnemonic(KeyEvent.VK_A);
		_mitemExit = new JMenuItem("終了(X)");
		_mitemExit.setMnemonic(KeyEvent.VK_X);
		_menuFile.add(_mitemOpen);
		_menuFile.add(_mitemDownload);
		_menuFile.add(_mitemSave);
		_menuFile.add(_mitemSaveAs);
		_menuFile.addSeparator();
		_menuFile.add(_mitemExit);
		_mitemOpen.addActionListener(this);
		_mitemDownload.addActionListener(this);
		_mitemSave.addActionListener(this);
		_mitemSaveAs.addActionListener(this);
		_mitemExit.addActionListener(this);

		_mitemVS14 = new JRadioButtonMenuItem("1/4倍");
		_mitemVS14.addActionListener(this);
		_mitemVS12 = new JRadioButtonMenuItem("1/2倍");
		_mitemVS12.addActionListener(this);
		_mitemVS11 = new JRadioButtonMenuItem("原寸大", true);
		_mitemVS11.addActionListener(this);

		ButtonGroup vsg = new ButtonGroup();
		vsg.add(_mitemVS14);
		vsg.add(_mitemVS12);
		vsg.add(_mitemVS11);

		_mitemJpgQuality = new JMenuItem("jpg保存品質(J)");
		_mitemJpgQuality.setMnemonic(KeyEvent.VK_J);
		_mitemJpgQuality.addActionListener(this);

		_smenuViewSize = new JMenu("表示倍率(S)");
		_smenuViewSize.setMnemonic(KeyEvent.VK_S);
		_smenuViewSize.addMenuListener(this);
		_smenuViewSize.add(_mitemVS14);
		_smenuViewSize.add(_mitemVS12);
		_smenuViewSize.add(_mitemVS11);

		_menuDef = new JMenu("設定(D)");
		_menuDef.setMnemonic(KeyEvent.VK_D);
		_menuDef.add(_smenuViewSize);
		_menuDef.add(_mitemJpgQuality);

		_menuEdit = new JMenu("編集(E)");
		_menuEdit.setMnemonic(KeyEvent.VK_E);
		_menuEdit.addMenuListener(this);
		_mitemUndo = new JMenuItem("元に戻す(U)");
		_mitemUndo.setMnemonic(KeyEvent.VK_U);
		_menuEdit.add(_mitemUndo);
		_mitemUndo.addActionListener(this);
		_mitemPaste = new JMenuItem("貼り付け(P)");
		_mitemPaste.setMnemonic(KeyEvent.VK_P);
		_menuEdit.add(_mitemPaste);
		_mitemPaste.addActionListener(this);
		_mitemCopy = new JMenuItem("コピー(C)");
		_mitemCopy.setMnemonic(KeyEvent.VK_C);
		_menuEdit.add(_mitemCopy);
		_mitemCopy.addActionListener(this);

		_menuInfo = new JMenu("画像情報(I)");
		_menuInfo.setMnemonic(KeyEvent.VK_I);
		_menuInfo.addMenuListener(this);
		_mitemSize = new JMenuItem("画像サイズ(S)");
		_mitemSize.setMnemonic(KeyEvent.VK_S);
		_menuInfo.add(_mitemSize);
		_mitemSize.addActionListener(this);
		_mitemColors = new JMenuItem("画像内色数(C)");
		_mitemColors.setMnemonic(KeyEvent.VK_C);
		_menuInfo.add(_mitemColors);
		_mitemColors.addActionListener(this);

		_menuTransform = new JMenu("変換(T)");
		_menuTransform.setMnemonic(KeyEvent.VK_T);
		_menuTransform.addMenuListener(this);
		_mitemResize = new JMenuItem("サイズ変更(S)");
		_mitemResize.setMnemonic(KeyEvent.VK_S);
		_menuTransform.add(_mitemResize);
		_mitemResize.addActionListener(this);
		_mitemRGBFunc = new JMenuItem("RGB変換(R)");
		_mitemRGBFunc.setMnemonic(KeyEvent.VK_R);
		_menuTransform.add(_mitemRGBFunc);
		_mitemRGBFunc.addActionListener(this);
		_mitemXor = new JMenuItem("色反転(X)");
		_mitemXor.setMnemonic(KeyEvent.VK_X);
		_menuTransform.add(_mitemXor);
		_mitemXor.addActionListener(this);
		_mitemGray = new JMenuItem("白黒化(G)");
		_mitemGray.setMnemonic(KeyEvent.VK_G);
		_menuTransform.add(_mitemGray);
		_mitemGray.addActionListener(this);

		_menuCond = new JMenu("調整(C)");
		_menuCond.setMnemonic(KeyEvent.VK_C);
		_mitemCondRGB = new JMenuItem("RGB調整(R)");
		_mitemCondRGB.setMnemonic(KeyEvent.VK_R);
		_menuCond.add(_mitemCondRGB);
		_mitemCondRGB.addActionListener(this);
		_mitemCondHSB = new JMenuItem("HSB調整(H)");
		_mitemCondHSB.setMnemonic(KeyEvent.VK_H);
		_menuCond.add(_mitemCondHSB);
		_mitemCondHSB.addActionListener(this);
		_mitemCondGamma = new JMenuItem("ガンマ補正(G)");
		_mitemCondGamma.setMnemonic(KeyEvent.VK_G);
		_menuCond.add(_mitemCondGamma);
		_mitemCondGamma.addActionListener(this);
		_mitemPost = new JMenuItem("階調変更(P)");
		_mitemPost.setMnemonic(KeyEvent.VK_P);
		_menuCond.add(_mitemPost);
		_mitemPost.addActionListener(this);

		_menuFilter =new JMenu("フィルタ(L)");
		_menuFilter.setMnemonic(KeyEvent.VK_L);
		_mitemBluer = new JMenuItem("ぼかし(B)");
		_mitemBluer.setMnemonic(KeyEvent.VK_B);
		_menuFilter.add(_mitemBluer);
		_mitemBluer.addActionListener(this);
		_mitemUnsharp = new JMenuItem("アンシャープマスク(U)");
		_mitemUnsharp.setMnemonic(KeyEvent.VK_U);
		_menuFilter.add(_mitemUnsharp);
		_mitemUnsharp.addActionListener(this);
		_mitemOilPaint = new JMenuItem("油絵風(O)");
		_mitemOilPaint.setMnemonic(KeyEvent.VK_O);
		_menuFilter.add(_mitemOilPaint);
		_mitemOilPaint.addActionListener(this);
		_mitemPcamera = new JMenuItem("ピンホールカメラ風(P)");
		_mitemPcamera.setMnemonic(KeyEvent.VK_P);
		_menuFilter.add(_mitemPcamera);
		_mitemPcamera.addActionListener(this);

		_menuHelp =new JMenu("ヘルプ(H)");
		_menuHelp.setMnemonic(KeyEvent.VK_H);
		_mitemAbout = new JMenuItem("バージョン情報(A)");
		_mitemAbout.setMnemonic(KeyEvent.VK_A);
		_menuHelp.add(_mitemAbout);
		_mitemAbout.addActionListener(this);

		_mbMain.add(_menuFile);
		_mbMain.add(_menuEdit);
		_mbMain.add(_menuDef);
		_mbMain.add(_menuInfo);
		_mbMain.add(_menuTransform);
		_mbMain.add(_menuCond);
		_mbMain.add(_menuFilter);
		_mbMain.add(_menuHelp);

		setJMenuBar(_mbMain);

		Container cp = getContentPane();

		m_frame = new JIntFrameBuffer(128, 128);

		m_bp = new BMPanel(this);
		m_bp.setFrameBuffer(m_frame);

		m_jp=new JScrollPane(m_bp, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		m_lState = new JLabel(" ", JLabel.LEFT);

		GridBagLayout gl = new GridBagLayout();
		cp.setLayout(gl);

		GridBagConstraints gc = new GridBagConstraints();

		gc.fill=GridBagConstraints.BOTH;
		gc.weightx=100;
		gc.weighty=100;
		gc.gridx=0;
		gc.gridy=0;
		gc.gridwidth=1;
		gc.gridheight=1;

		cp.add(m_jp,gc);

		gc.weightx=100;
		gc.weighty=0;
		gc.gridx=0;
		gc.gridy=1;
		gc.gridwidth=1;
		gc.gridheight=1;

		cp.add(m_lState,gc);

		new DropTarget(this, DnDConstants.ACTION_COPY_OR_MOVE, this, true);

		_undo = new JIntFrameBuffer[UNDO_LEVEL];
		_undoIndex = -1;

		// jpg保存品質初期設定
		_jpgQuality = 80;

		// 表示サイズ原寸大
		_vsSize = 100;

		// ダイアログ内のプレビューサイズ設定
		PREVIEW_SIZE = 160;

		// 上書き保存無効
		_save = false;

		setTitle(_appName);

		setVisible(true);
		setDefaultCloseOperation(EXIT_ON_CLOSE);

	}

	// クリップボードの画像を取得
	private Image getClipboardImage() {

		Clipboard cb = Toolkit.getDefaultToolkit().getSystemClipboard();

		if (cb == null) {
			return null;
		}

		Transferable trans = cb.getContents(this);

        if(trans == null) {
			return null;
		}

        DataFlavor[] flavors = trans.getTransferDataFlavors();
        DataFlavor imageflavor = null;

        for(int i=0; i<flavors.length; i++) {
            if(flavors[i].getRepresentationClass().equals(Image.class)) {
                imageflavor = flavors[i];
                break;
            }
        }

        if(imageflavor == null) {
			return null;
		}

        try {
            Image image = (Image)trans.getTransferData(imageflavor);
            return image;
        } catch (Exception e) {
		}

        return null;

    }

	public void actionPerformed(ActionEvent e) {

		// 「開く」メニュー
		if (e.getSource() == _mitemOpen) {

			JFileChooser jf = new JFileChooser();

			if (_currentDir != null) {
				jf.setCurrentDirectory(_currentDir);
			}

			jf.setFileFilter(new j8phImageFileFilter());

			if (jf.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {

				byte[] data = loadFile(jf.getSelectedFile());

				int[] img = j8phImageCodec.decode(data);

				if (!m_frame.assign(img)) {
					return;
				}

				String path = jf.getSelectedFile().getAbsolutePath();

				setTitle(_appName + " - " + path);

				_currentDir = jf.getCurrentDirectory();
				_currentFile = new File(path);

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

				clearUndo();
				_save = false;

			}

			repaint();

		}

		// 「ダウンロード」メニュー
		if (e.getSource() == _mitemDownload) {

			DownloadURLDialog dlg = new DownloadURLDialog(this);

			dlg.show();

			if (dlg.getURL() != null) {

				Image img = null;

				try {
					img = ImageIO.read(new URL(dlg.getURL()));
				} catch (Exception ex) {
					img = null;
				}

				if (img == null) {
					return;
				}

				m_frame.assign(img);

				setTitle("");
				_save = false;

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

				clearUndo();

			}

			repaint();

		}

		// 「上書き保存」メニュー
		if (e.getSource() == _mitemSave) {

			String path = _currentFile.getAbsolutePath();
			int extIndex = path.lastIndexOf(".") + 1;

			if (extIndex > 1) {

				String ext = path.substring(extIndex);

				if (ext != null && ext.length() > 0) {

					int[] pixels = m_frame.getPixels();
					byte[] data = j8phImageCodec.encode(pixels, ext.toLowerCase(), _jpgQuality);

					if (data != null && data.length > 0 && writeFile(data, new File(path))) {
						_save = false;
					} else {
						JOptionPane.showMessageDialog(this, "画像を保存できませんでした。", "保存失敗", JOptionPane.PLAIN_MESSAGE);

					}

				}

			}

		}

		// 「名前をつけて保存」メニュー
		if (e.getSource() == _mitemSaveAs) {

			JFileChooser jf = new JFileChooser();

			if (_currentDir != null) {
				jf.setCurrentDirectory(_currentDir);
			}

			jf.setFileFilter(new j8phImageFileFilter());

			if (jf.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {

				File f = jf.getSelectedFile();

				if (f.exists() && JOptionPane.showConfirmDialog(this, "上書きしますか？", "上書き確認", JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION) {
					return;
				}

				String path = f.getAbsolutePath();
				int extIndex = path.lastIndexOf(".") + 1;

				if (extIndex > 1) {

					String ext = path.substring(extIndex);

					if (ext != null && ext.length() > 0) {

						int[] pixels = m_frame.getPixels();
						byte[] data = j8phImageCodec.encode(pixels, ext.toLowerCase(), _jpgQuality);

						if (data != null && data.length > 0) {

							if (writeFile(data, new File(path))) {

								_currentFile = new File(path);

								setTitle(_appName + " - " + path);

								_save = false;

							} else {
								JOptionPane.showMessageDialog(this, "画像を保存できませんでした。", "保存失敗", JOptionPane.PLAIN_MESSAGE);
							}

						} else {
							JOptionPane.showMessageDialog(this, "画像を保存できませんでした。", "保存失敗", JOptionPane.PLAIN_MESSAGE);
						}

					} else {
						JOptionPane.showMessageDialog(this, "ファイル名にはbmp/jpg/png拡張子をつけてください。", "保存失敗", JOptionPane.PLAIN_MESSAGE);
					}

				} else {
					JOptionPane.showMessageDialog(this, "ファイル名にはbmp/jpg/png拡張子をつけてください。", "保存失敗", JOptionPane.PLAIN_MESSAGE);
				}

			}

			repaint();

		}

		// 「終了」メニュー
		if (e.getSource() == _mitemExit) {

			dispose();
			System.exit(0);

		}

		// 「1/4倍」メニュー
		if (e.getSource() == _mitemVS14) {

			m_bp.setViewSize(0.25);
			m_jp.setViewport(m_jp.getViewport());
			repaint();

			_vsSize = 25;

		}

		// 「1/2倍」メニュー
		if (e.getSource() == _mitemVS12) {

			m_bp.setViewSize(0.5);
			m_jp.setViewport(m_jp.getViewport());
			repaint();

			_vsSize = 50;

		}

		// 「原寸大」メニュー
		if (e.getSource() == _mitemVS11) {

			m_bp.setViewSize(1.0);
			m_jp.setViewport(m_jp.getViewport());
			repaint();

			_vsSize = 100;

		}

		// 「jpg保存品質」メニュー
		if (e.getSource() == _mitemJpgQuality) {

			JpgQualityDialog dlg = new JpgQualityDialog(this, _jpgQuality);

			dlg.show();

			if (dlg.getJpgQuality() > 0) {

				_jpgQuality = dlg.getJpgQuality();

			}

			repaint();

		}

		// 「元に戻す」メニュー
		if (e.getSource() == _mitemUndo) {

			JIntFrameBuffer undo = loadUndo();

			if (undo != null) {

				m_frame.assign(undo.getPixels());

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

				repaint();

			}

		}

		// 「貼り付け」メニュー
		if (e.getSource() == _mitemPaste) {

			Image img = getClipboardImage();

			if (img == null) {
				return;
			}

			m_frame.assign(img);

			setTitle("");
			_save = false;

			m_bp.setFrameBuffer(m_frame);

			m_jp.setViewport(m_jp.getViewport());

			clearUndo();

		}

		// 「コピー」メニュー
		if (e.getSource() == _mitemCopy) {

			ImageSelection is = new ImageSelection(m_frame.getImage());

			Toolkit.getDefaultToolkit().getSystemClipboard().setContents(is, is);

		}

		// 「画像サイズ」メニュー
		if (e.getSource() == _mitemSize) {

			// 画像サイズをダイアログで表示
			JOptionPane.showMessageDialog(this, "画像サイズ:" + m_frame.getWidth() + "×" + m_frame.getHeight() + "ピクセル", "画像サイズ", JOptionPane.PLAIN_MESSAGE);

			repaint();

		}

		// 「画像内色数」メニュー
		if (e.getSource() == _mitemColors) {

			// 画像の色数を取得
			int colors = m_frame.getColors();

			// 色数をダイアログで表示
			JOptionPane.showMessageDialog(this, "色数:" + colors, "画像内色数", JOptionPane.PLAIN_MESSAGE);

			repaint();

		}

		// 「サイズ変更」メニュー
		if (e.getSource() == _mitemResize) {

			ResizeDialog dlg = new ResizeDialog(this);

			dlg.setOriginalSize(m_frame.getWidth(), m_frame.getHeight());
			dlg.show();

			if (dlg.getImageSize() != null) {

				saveUndo();

				int width = dlg.getImageSize().width;
				int height = dlg.getImageSize().height;

				if (width > 0 && height > 0) {

					int[] pixels = m_frame.getScaledPixels(width, height);

					if (pixels != null && m_frame.assign(pixels)) {

						m_bp.setFrameBuffer(m_frame);

						m_jp.setViewport(m_jp.getViewport());

					}

				}

			}

			repaint();

		}

		// 「RGB変換」メニュー
		if (e.getSource() == _mitemRGBFunc) {

			RGBFuncDialog dlg = new RGBFuncDialog(this, m_frame);

			dlg.show();

			if (dlg.getValue() != null) {

				saveUndo();

				m_frame.rgbFunc(dlg.getValue());

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

			}

			repaint();

		}

		// 「RGB調整」メニュー
		if (e.getSource() == _mitemCondRGB) {

			RGBCondDialog dlg = new RGBCondDialog(this, m_frame);

			dlg.show();

			if (dlg.getR() < 256) {

				saveUndo();

				int dr = dlg.getR();
				int dg = dlg.getG();
				int db = dlg.getB();

				m_frame.addRGB(dr, dg, db);

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

			}

			repaint();

		}

		// 「HSB調整」メニュー
		if (e.getSource() == _mitemCondHSB) {

			HSBCondDialog dlg = new HSBCondDialog(this, m_frame);

			dlg.show();

			if (dlg.getH() < 256) {

				saveUndo();

				int dh = dlg.getH();
				int ds = dlg.getS();
				int db = dlg.getB();

				m_frame.addHSB(dh, ds, db);

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

			}

			repaint();

		}

		// 「ガンマ補正」メニュー
		if (e.getSource() == _mitemCondGamma) {

			GammaCondDialog dlg = new GammaCondDialog(this, m_frame);

			dlg.show();

			if (dlg.getGamma() >= 0) {

				saveUndo();

				m_frame.gamma((double)dlg.getGamma() / 100.0);

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

			}

			repaint();

		}

		// 「階調変更」メニュー
		if (e.getSource() == _mitemPost) {

			PostDialog dlg = new PostDialog(this, m_frame);

			dlg.show();

			if (dlg.getR() >= 0) {

				saveUndo();

				m_frame.post(dlg.getR(), dlg.getG(), dlg.getB());

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

			}

			repaint();

		}

		// 「ぼかし」メニュー
		if (e.getSource() == _mitemBluer) {

			BluerDialog dlg = new BluerDialog(this, m_frame);

			dlg.show();

			if (dlg.get0Pix() >= 0) {

				saveUndo();

				m_frame.bluer(dlg.get0Pix(), dlg.get1Pix(), dlg.get2Pix());

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

			}

			repaint();

		}

		// 「アンシャープマスク」メニュー
		if (e.getSource() == _mitemUnsharp) {

			UnsharpDialog dlg = new UnsharpDialog(this, m_frame);

			dlg.show();

			if (dlg.getRange() > 0) {

				saveUndo();

				m_frame.unsharp(dlg.getRange(), (double)(dlg.getVal()) / 10.0);

				m_bp.setFrameBuffer(m_frame);

				m_jp.setViewport(m_jp.getViewport());

			}

			repaint();

		}

		// 「油絵風」メニュー
		if (e.getSource() == _mitemOilPaint) {

			saveUndo();

			m_frame.oilPaint();

			m_bp.setFrameBuffer(m_frame);

			m_jp.setViewport(m_jp.getViewport());

			repaint();

		}

		// 「ピンホールカメラ」メニュー
		if (e.getSource() == _mitemPcamera) {

			saveUndo();

			m_frame.pcamera();

			m_bp.setFrameBuffer(m_frame);

			m_jp.setViewport(m_jp.getViewport());

			repaint();

		}

		// 「色反転」メニュー
		if (e.getSource() == _mitemXor) {

			saveUndo();

			int r,g,b;

			// 各ピクセルをXor
			for (int i=0;i<m_frame.getHeight();i++)
				for (int j=0;j<m_frame.getWidth();j++) {

					r=m_frame.getR(j,i);
					g=m_frame.getG(j,i);
					b=m_frame.getB(j,i);

					r=r ^ 0xff;
					g=g ^ 0xff;
					b=b ^ 0xff;

					m_frame.setR(j,i,r);
					m_frame.setG(j,i,g);
					m_frame.setB(j,i,b);

				}

			// パネルコンポーネントをm_frameで更新
			m_bp.setFrameBuffer(m_frame);

			repaint();

		}

		// 「白黒化」メニュー
		if (e.getSource() == _mitemGray) {

			saveUndo();

			// 白黒化処理実行
			m_frame.gray();

			// パネルコンポーネントをm_frameで更新
			m_bp.setFrameBuffer(m_frame);

			repaint();

		}

		// 「バージョン情報」メニュー
		if (e.getSource() == _mitemAbout) {

			// バージョン情報を表示
			JOptionPane.showMessageDialog(this, "Javaフォトレタッチ Version 0.91 (C)2008 宍戸　輝光", "バージョン情報", JOptionPane.PLAIN_MESSAGE);

			repaint();

		}

	}

	private void clearUndo() {

		if (_undoIndex >= 0) {

			for (int i = 0;i <= _undoIndex;i++) {
				_undo[i] = null;
			}

			System.gc();

			_undoIndex = -1;

		}

	}

	private void saveUndo() {

		_save = true;

		if (_undoIndex == UNDO_LEVEL - 1) {

			for (int i = 0;i < _undoIndex;i++) {

				_undo[i] = null;

				System.gc();

				_undo[i] = _undo[i + 1];

			}

			_undo[UNDO_LEVEL - 1] = null;

		} else {
			_undo[++_undoIndex] = new JIntFrameBuffer(m_frame);
		}

	}

	private JIntFrameBuffer loadUndo() {

		if (_undoIndex < 0 || _undo[_undoIndex] == null) {
			return null;
		}

		return _undo[_undoIndex--];

	}

	public void menuCanceled(MenuEvent e) {}

	public void menuDeselected(MenuEvent e) {}

	public void menuSelected(MenuEvent e) {

		// 「ファイル」メニューポップアップ時
		if (e.getSource() == _menuFile) {

			// 「上書き保存」メニュー設定
			_mitemSave.setEnabled(_save && _currentFile != null);

		}

		// 「編集」メニューポップアップ時
		if (e.getSource() == _menuEdit) {

			// 履歴があれば、「元に戻す」メニュー有効
			_mitemUndo.setEnabled(_undoIndex >= 0);

			// クリップボードに画像があれば「貼り付け」メニュー有効
			if (getClipboardImage() != null) {
				_mitemPaste.setEnabled(true);
			} else {
				_mitemPaste.setEnabled(false);
			}

		}

	}

	public void setStatus(String stArg) {

		m_lState.setText(stArg);

	}

	private boolean writeFile(byte[] data, File f) {

		FileOutputStream os = null;

		try {
			os = new FileOutputStream(f);
		} catch (Exception e) {
			os = null;
		}

		if (os == null) {
			return false;
		}

		boolean result = true;

		try {
			os.write(data);
		} catch (Exception e) {
			result = false;
		}

		try {
			os.close();
		} catch (Exception e) {
		}

		return result;

	}

	private byte[] loadFile(File f) {

		if (f == null) {
			return null;
		}

		int size = (int)(f.length());

		if (size < 1) {
			return null;
		}

		byte[] data = new byte[size];

		if (data == null) {
			return null;
		}

		FileInputStream is = null;

		try {
			is = new FileInputStream(f);
		} catch (Exception e) {
			is = null;
		}

		if (is == null) {
			return null;
		}

		try {

			int index = 0;
			int restSize = size;
			int loadSize = 0;

			while ((restSize > 0) && (loadSize = is.read(data, index, restSize)) != -1) {

				index += loadSize;
				restSize -= loadSize;

			}

			is.close();

		} catch (Exception e) {}

		return data;

	}

	public void dragEnter(DropTargetDragEvent e) {
		e.acceptDrag(DnDConstants.ACTION_COPY_OR_MOVE);
	}

	public void dragExit(DropTargetEvent e) {}
	public void dragOver(DropTargetDragEvent e) {}
	public void dropActionChanged(DropTargetDragEvent e) {}

	// ファイルドロップ時の処理
	public void drop(DropTargetDropEvent e) {

		e.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);

		java.util.List files = null;

		// ドロップされたファイルの情報を取得
		try {

			Transferable trans = e.getTransferable();

			files = (java.util.List)trans.getTransferData(DataFlavor.javaFileListFlavor);

		} catch (Exception ex) {
			files = null;
		}

		if (files == null) {

			e.dropComplete(true);

			return;

		}

		File f = (File)files.get(0);

		byte[] data = loadFile(f);

		e.dropComplete(true);

		if (data == null) {
			return;
		}

		int[] img = j8phImageCodec.decode(data);

		if (!m_frame.assign(img)) {
			return;
		}

		String path = f.getAbsolutePath();

		setTitle(_appName + " - " + path);

		_currentDir = f.getParentFile();
		_currentFile = new File(path);

		m_bp.setFrameBuffer(m_frame);

		m_jp.setViewport(m_jp.getViewport());

		clearUndo();

		repaint();

	}

	public static void main(String stArgs[]) {

		j8ph ap = new j8ph();

	}

}
